#include <Arduino.h>

void setup() {
  Serial.begin(115200);   // Initialize serial communication
  delay(1000);            // Wait for Serial Monitor to open
  Serial.println("Starting Performance Test...");

  // 1. Test Arithmetic Speed
  unsigned long startTime = millis();
  volatile long sum = 0;
  for (long i = 0; i < 100000; i++) {
    sum += i;
  }
  unsigned long endTime = millis();
  Serial.print("Arithmetic Time: ");
  Serial.print(endTime - startTime);
  Serial.println(" ms");

  // 2. Test Digital I/O Speed
  pinMode(2, OUTPUT);  // Use GPIO2 as output
  startTime = millis();
  for (long i = 0; i < 100000; i++) {
    digitalWrite(2, HIGH);
    digitalWrite(2, LOW);
  }
  endTime = millis();
  Serial.print("Digital I/O Time: ");
  Serial.print(endTime - startTime);
  Serial.println(" ms");

  // 3. Test Delay Accuracy
  startTime = millis();
  delay(1000);  // 1-second delay
  endTime = millis();
  Serial.print("Delay Accuracy: ");
  Serial.print(endTime - startTime);
  Serial.println(" ms");

  Serial.println("Performance Test Completed.");
}

void loop() {
  // Empty loop
}
